package skyjed.gui;

import java.awt.*;
import java.awt.event.ActionEvent;

import javax.swing.*;
import javax.swing.border.EmptyBorder;

public class AboutDialog {

    private JDialog dialog;

    private Action okAction = new AbstractAction("OK") {
        public void actionPerformed(ActionEvent ev) {
            dialog.dispose();
        }
    };

    /**
     * Create the dialog.
     */
    public AboutDialog() {
        initialize();
        dialog.setVisible(true);
    }

    /**
     * Initialize the contents of the frame.
     */
    private void initialize() {
        dialog = new JDialog();
        dialog.setTitle("About");
        dialog.setLocationByPlatform(true);
        dialog.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        dialog.setModalityType(Dialog.ModalityType.APPLICATION_MODAL);
        dialog.getContentPane().setLayout(new BorderLayout());

        JPanel contentPanel = new JPanel();
        contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
        dialog.getContentPane().add(contentPanel, BorderLayout.CENTER);

        contentPanel.setLayout(new FlowLayout());
        {
            JTextArea txtrSkySaveEditor = new JTextArea();
            txtrSkySaveEditor.setFont(UIManager.getFont("TextField.font"));
            txtrSkySaveEditor.setBackground(dialog.getBackground());
            txtrSkySaveEditor.setText(
                    "Sky save editor, v0.8i\n" +
                    "by matix2267 <matix2267@gmail.com>\n\n" +
                    "based on Sky Editor by Evandixon\n" +
                    "thanks to Grovyle91, Prof. 9\n" +
                    "and WhatHappenedToStairs for their research.");
            txtrSkySaveEditor.setEditable(false);
            contentPanel.add(txtrSkySaveEditor);
        }
        {
            JPanel buttonPane = new JPanel();
            buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
            dialog.getContentPane().add(buttonPane, BorderLayout.SOUTH);
            {
                JButton okButton = new JButton(okAction);
                buttonPane.add(okButton);
                dialog.getRootPane().setDefaultButton(okButton);
            }
        }

        dialog.pack();
        dialog.setResizable(false);
    }

}
