package skyjed.gui;

import java.awt.FlowLayout;

import javax.swing.JComboBox;
import javax.swing.JPanel;

import skyjed.resources.PropertyItem;
import skyjed.resources.SkyAttackRes;
import skyjed.save.SkyAttack;
import skyjed.util.ArrayListModel;
import skyjed.util.JBooleanLabel;
import skyjed.util.JNumberSpinner;

public class AttackEditPanel extends JPanel {

    private static final int GINSENG_MAX = 99;

    private SkyAttack attack;

    private JBooleanLabel lblIsValid;
    private JBooleanLabel lblIsLinked;
    private JBooleanLabel lblIsSwitched;
    private JBooleanLabel lblIsSet;
    private JComboBox<PropertyItem> cmbAttackName;
    private JNumberSpinner spnGinseng;

    public SkyAttack getAttack() {
        attack = new SkyAttack();
        attack.isvalid = lblIsValid.getBool();
        attack.islinked = lblIsLinked.getBool();
        attack.isswitched = lblIsSwitched.getBool();
        attack.isset = lblIsSet.getBool();
        attack.ginseng = spnGinseng.getValueInt();
        attack.no = cmbAttackName.getSelectedIndex();
        return attack;
    }

    public void setAttack(SkyAttack attack) {
        this.attack = attack;
        if(attack == null) {
            attack = new SkyAttack();
        }
        lblIsValid.setBool(attack.isvalid);
        lblIsLinked.setBool(attack.islinked);
        lblIsSwitched.setBool(attack.isswitched);
        lblIsSet.setBool(attack.isset);
        cmbAttackName.setSelectedIndex(attack.no);
        spnGinseng.setValue(attack.ginseng);
    }

    /**
     * Create the panel.
     */
    public AttackEditPanel() {
        initialize();
    }

    /**
     * Initialize the contents of the frame.
     */
    private void initialize() {
        setSize(120, 22);
        setLayout(new FlowLayout(FlowLayout.CENTER, 0, 0));
        {
            lblIsValid = new JBooleanLabel();
            lblIsValid.setToolTipText("is valid");
            add(lblIsValid);
        }
        {
            lblIsLinked = new JBooleanLabel();
            lblIsLinked.setToolTipText("is linked");
            add(lblIsLinked);
        }
        {
            lblIsSwitched = new JBooleanLabel();
            lblIsSwitched.setToolTipText("is switched on");
            add(lblIsSwitched);
        }
        {
            lblIsSet = new JBooleanLabel();
            lblIsSet.setToolTipText("is set");
            add(lblIsSet);
        }
        {
            cmbAttackName = new JComboBox<PropertyItem>();
            cmbAttackName.setModel(new ArrayListModel<PropertyItem>(SkyAttackRes.getInstance().getPropertyList()));
            add(cmbAttackName);
        }
        {
            spnGinseng = new JNumberSpinner(GINSENG_MAX);
            spnGinseng.setToolTipText("Ginseng");
            add(spnGinseng);
        }
    }

}
