package skyjed.gui;

import java.awt.FlowLayout;

import javax.swing.JComboBox;
import javax.swing.JPanel;

import skyjed.resources.PropertyItem;
import skyjed.resources.SkyAttackRes;
import skyjed.save.SkyAttackQ;
import skyjed.util.ArrayListModel;
import skyjed.util.JBooleanLabel;
import skyjed.util.JNumberSpinner;

public class AttackQEditPanel extends JPanel {

    private static final int GINSENG_MAX = 99;
    private static final int PP_MAX = 99;

    private SkyAttackQ attack;

    private JBooleanLabel lblIsValid;
    private JBooleanLabel lblIsLinked;
    private JBooleanLabel lblIsSwitched;
    private JBooleanLabel lblIsSet;
    private JBooleanLabel lblIsSealed;
    private JComboBox<PropertyItem> cmbAttackName;
    private JNumberSpinner spnGinseng;
    private JNumberSpinner spnPP;

    public SkyAttackQ getAttackQ() {
        attack = new SkyAttackQ();
        attack.isvalid = lblIsValid.getBool();
        attack.islinked = lblIsLinked.getBool();
        attack.isswitched = lblIsSwitched.getBool();
        attack.isset = lblIsSet.getBool();
        attack.issealed = lblIsSealed.getBool();
        attack.no = cmbAttackName.getSelectedIndex();
        attack.ginseng = spnGinseng.getValueInt();
        attack.pp = spnPP.getValueInt();
        return attack;
    }

    public void setAttackQ(SkyAttackQ attack) {
        this.attack = attack;
        if(attack == null) {
            attack = new SkyAttackQ();
        }
        lblIsValid.setBool(attack.isvalid);
        lblIsLinked.setBool(attack.islinked);
        lblIsSwitched.setBool(attack.isswitched);
        lblIsSet.setBool(attack.isset);
        lblIsSealed.setBool(attack.issealed);
        cmbAttackName.setSelectedIndex(attack.no);
        spnGinseng.setValue(attack.ginseng);
        spnPP.setValue(attack.pp);
    }

    /**
     * Create the panel.
     */
    public AttackQEditPanel() {
        initialize();
    }

    /**
     * Initialize the contents of the frame.
     */
    private void initialize() {
        setSize(120, 22);
        setLayout(new FlowLayout(FlowLayout.CENTER, 0, 0));
        {
            lblIsValid = new JBooleanLabel();
            lblIsValid.setToolTipText("is valid");
            add(lblIsValid);
        }
        {
            lblIsLinked = new JBooleanLabel();
            lblIsLinked.setToolTipText("is linked");
            add(lblIsLinked);
        }
        {
            lblIsSwitched = new JBooleanLabel();
            lblIsSwitched.setToolTipText("is switched on");
            add(lblIsSwitched);
        }
        {
            lblIsSet = new JBooleanLabel();
            lblIsSet.setToolTipText("is set");
            add(lblIsSet);
        }
        {
            lblIsSealed = new JBooleanLabel();
            lblIsSealed.setToolTipText("is sealed?");
            add(lblIsSealed);
        }
        {
            cmbAttackName = new JComboBox<PropertyItem>();
            cmbAttackName.setModel(new ArrayListModel<PropertyItem>(SkyAttackRes.getInstance().getPropertyList()));
            add(cmbAttackName);
        }
        {
            spnGinseng = new JNumberSpinner(GINSENG_MAX);
            spnGinseng.setToolTipText("Ginseng");
            add(spnGinseng);
        }
        {
            spnPP = new JNumberSpinner(PP_MAX);
            spnPP.setToolTipText("PP");
            add(spnPP);
        }
    }

}
