package skyjed.gui.action;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

/**
 * @param <T> Type of item
 * @param <C> Type of component containing it
 */
public class UpdateItemAction<T, C extends ILoadStoreValues<T>> extends AbstractAction {

    private final T item;
    private final C component;

    public UpdateItemAction(String name, T item, C component) {
        super(name);
        this.item = item;
        this.component = component;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        component.storeValues(item);
    }

}
