package skyjed.gui.action;

import java.awt.event.ActionEvent;
import java.util.List;

import javax.swing.AbstractAction;
import javax.swing.JList;

/**
 * @param <T> Type of item
 * @param <C> Type of component containing it
 */
public class UpdateSelectedItemsInJListAction<T, C extends ILoadStoreValues<T>> extends AbstractAction {

    private final JList<T> tList;
    private final C component;

    public UpdateSelectedItemsInJListAction(String name, JList<T> tList, C component) {
        super(name);
        this.tList = tList;
        this.component = component;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        List<T> ts = tList.getSelectedValuesList();
        for(T t : ts) {
            component.storeValues(t);
        }
        // refresh the list
        tList.repaint();
    }

}
