package skyjed.gui.util;

import javax.swing.JScrollPane;

public class ByteEdit extends JScrollPane {

    private static final int NUM_COLUMNS = 16;

    private int len;
    private Byte[][] tabdata;

    public ByteEdit(byte[] data) {
        setData(data);
    }

    public byte[] getData() {
        byte[] data = new byte[len];
        for(int i=0; i<len; i++) {
            data[i] = tabdata[i/NUM_COLUMNS][i%NUM_COLUMNS];
        }
        return data;
    }

    public void setData(byte[] data) {
        len = data.length;
        tabdata = new Byte[(len+NUM_COLUMNS-1)/NUM_COLUMNS][NUM_COLUMNS];
        for(int i=0; i<len; i++) {
            tabdata[i/NUM_COLUMNS][i%NUM_COLUMNS] = data[i];
        }
        this.setViewportView(new ByteTable(tabdata));
    }

}
