package skyjed.resources;

import java.io.IOException;
import java.util.Properties;

import skyjed.util.ExceptionHandler;

/**
 * Used to simplify loading of resources from <tt>*.properties</tt> files.
 * <br><br>
 * All keys <b>must</b> be consecutive integers, starting from 0.
 */
public class PropertiesListLoader {

    protected Properties data = null;

    protected PropertiesListLoader(String filename) {
        data = new Properties();
        try {
            data.load(PropertiesListLoader.class.getClassLoader().getResourceAsStream(filename));
        } catch(IOException e) {
            ExceptionHandler.handleException(e, null);
        }
    }

    public String getValue(int id) {
        return data.getProperty(Integer.toString(id), "<ERROR>");
    }

    public PropertyItem[] getPropertyList() {
        PropertyItem[] ret = new PropertyItem[data.size()];
        for(int i=0; i<data.size(); i++) {
            ret[i] = new PropertyItem(i, getValue(i));
        }
        return ret;
    }
}
