package skyjed.resources;

import java.util.HashMap;
import java.util.Map;

public class SkyCharsetRes extends PropertiesHexListLoader {

    private static SkyCharsetRes instance = null;

    public static SkyCharsetRes getInstance() {
        if(instance == null) {
            instance = new SkyCharsetRes();
        }
        return instance;
    }

    private SkyCharsetRes() {
        super("skyjed/resources/SkyCharset.properties");
        str2byteMap = new HashMap<String, Byte>(data.size()*4/3);
        for(int i=0; i<data.size(); i++) {
            str2byteMap.put(getValue(i), (byte) i);
        }
    }

    public String byte2str(byte b) {
        // java byte is always signed
        return getValue(b & 0xFF);
    }

    /**
     * Converts given string representation to byte value as used in-game.
     * String should be either single Unicode code-point (not the same as code-unit)
     * or special sequence in square brackets like "[e]" (this gives small letter e).
     * The game does not support '[' character, even though ']' works so we can use it as an escape sequence.
     */
    public byte str2byte(String str) {
        Byte b = str2byteMap.get(str);
        return b != null ? b : (byte) '?';
    }

    public byte char2byte(char c) {
        return str2byte(String.valueOf(c));
    }

    public boolean isValidStr(String str) {
        return str2byteMap.containsKey(str);
    }

    public boolean isValidChar(char c) {
        return isValidStr(String.valueOf(c));
    }

    private Map<String, Byte> str2byteMap;

}
