package skyjed.save;

import skyjed.buffer.BooleanBuffer;

public class HeldItemStorage {

    private static final int NUM_ITEMS = 50;
    private static final int LEN_ITEM = 33;

    public static final int LENGTH = NUM_ITEMS * LEN_ITEM;

    public SkyItem[] items;

    public HeldItemStorage() {
        items = new SkyItem[NUM_ITEMS];
        for(int i=0; i<NUM_ITEMS; i++) {
            items[i] = new SkyItem();
        }
    }

    public HeldItemStorage(BooleanBuffer buf) {
        this();
        load(buf);
    }

    public void load(BooleanBuffer buf) {
        for(int i=0; i<NUM_ITEMS; i++) {
            items[i].load(buf.view(LEN_ITEM));
        }
    }

    public void store(BooleanBuffer buf) {
        for(int i=0; i<NUM_ITEMS; i++) {
            items[i].store(buf.view(LEN_ITEM));
        }
    }

}
