package skyjed.save;

import skyjed.buffer.BooleanBuffer;

public class ItemShop {

    private static final int LEN_ID = 11;
    private static final int LEN_PARAM = 11;

    public SkyItem[] items;

    public ItemShop(int numItems) {
        items = new SkyItem[numItems];
        for(int i=0; i<items.length; i++) {
            items[i] = new SkyItem();
        }
    }

    public ItemShop(BooleanBuffer buf) {
        this(buf.remaining()/(LEN_ID+LEN_PARAM));
        load(buf);
    }

    public void load(BooleanBuffer buf) {
        for(int i=0; i<items.length; i++) {
            int id = buf.getInt(LEN_ID);
            int param = buf.getInt(LEN_PARAM);
            items[i] = new SkyItem(id, param);
        }
    }

    public void store(BooleanBuffer buf) {
        for(int i=0; i<items.length; i++) {
            buf.putInt(items[i].id, LEN_ID);
            buf.putInt(items[i].param, LEN_PARAM);
        }
    }

}
