package skyjed.save;

import skyjed.buffer.BooleanBuffer;

public class ItemShopNoParams {

    private static final int LEN_ID = 11;

    public SkyItem[] items;

    public ItemShopNoParams(int numItems) {
        items = new SkyItem[numItems];
        for(int i=0; i<items.length; i++) {
            items[i] = new SkyItem();
        }
    }

    public ItemShopNoParams(BooleanBuffer buf) {
        this(buf.remaining()/(LEN_ID));
        load(buf);
    }

    public void load(BooleanBuffer buf) {
        for(int i=0; i<items.length; i++) {
            int id = buf.getInt(LEN_ID);
            items[i] = new SkyItem(id, 0);
        }
    }

    public void store(BooleanBuffer buf) {
        for(int i=0; i<items.length; i++) {
            buf.putInt(items[i].id, LEN_ID);
        }
    }

}
