package skyjed.save;

import skyjed.buffer.BooleanBuffer;

public class ItemStorage {

    private static final int NUM_ITEMS = 1000;
    private static final int LEN_ID = 11;
    private static final int LEN_PARAM = 11;

    public SkyItem[] items;

    public ItemStorage() {
        items = new SkyItem[NUM_ITEMS];
        for(int i=0; i<NUM_ITEMS; i++) {
            items[i] = new SkyItem();
        }
    }

    public ItemStorage(BooleanBuffer buf) {
        this();
        load(buf);
    }

    public void load(BooleanBuffer buf) {
        BooleanBuffer buf_ids = buf.view(NUM_ITEMS * LEN_ID);
        BooleanBuffer buf_params = buf.view(NUM_ITEMS * LEN_PARAM);
        for(int i=0; i<NUM_ITEMS; i++) {
            items[i] = new SkyItem(buf_ids.getInt(LEN_ID), buf_params.getInt(LEN_PARAM));
        }
    }

    public void store(BooleanBuffer buf) {
        BooleanBuffer buf_ids = buf.view(NUM_ITEMS * LEN_ID);
        BooleanBuffer buf_params = buf.view(NUM_ITEMS * LEN_PARAM);
        for(int i=0; i<NUM_ITEMS; i++) {
            buf_ids.putInt(items[i].id, LEN_ID);
            buf_params.putInt(items[i].param, LEN_PARAM);
        }
    }

}
