package skyjed.save;

import skyjed.buffer.BooleanBuffer;

public class PkmnExStorage {

    private static final int PKMN_NUM = 4;
    private static final int PKMN_SIZE = 546;

    public SkyPkmnEx[] pkmns;

    public PkmnExStorage() {
        pkmns = new SkyPkmnEx[PKMN_NUM];
        for(int i=0; i<PKMN_NUM; i++) {
            pkmns[i] = new SkyPkmnEx();
        }
    }

    public PkmnExStorage(BooleanBuffer buf) {
        this();
        load(buf);
    }

    public void load(BooleanBuffer buf) {
        for(int i=0; i<PKMN_NUM; i++) {
            pkmns[i].load(buf.view(PKMN_SIZE));
        }
    }

    public void store(BooleanBuffer buf) {
        for(int i=0; i<PKMN_NUM; i++) {
            pkmns[i].store(buf.view(PKMN_SIZE));
        }
    }

}
