package skyjed.save;

import skyjed.buffer.BooleanBuffer;

public class PkmnQStorage {

    private static final int PKMN_NUM = 20;
    private static final int PKMN_BYTE_SIZE = 429;

    public SkyPkmnQ[] pkmns;

    public PkmnQStorage() {
        pkmns = new SkyPkmnQ[PKMN_NUM];
        for(int i=0; i<PKMN_NUM; i++) {
            pkmns[i] = new SkyPkmnQ();
        }
    }

    public PkmnQStorage(BooleanBuffer buf) {
        this();
        load(buf);
    }

    public void load(BooleanBuffer buf) {
        for(int i=0; i<PKMN_NUM; i++) {
            pkmns[i].load(buf.view(8*PKMN_BYTE_SIZE));
        }
    }

    public void store(BooleanBuffer buf) {
        for(int i=0; i<PKMN_NUM; i++) {
            pkmns[i].store(buf.view(8*PKMN_BYTE_SIZE));
        }
    }

}
