package skyjed.save;

import skyjed.buffer.BooleanBuffer;

public class PkmnStorage {

    private static final int PKMN_NUM = 555;
    private static final int PKMN_SIZE = 362;

    public SkyPkmn[] pkmns;

    public PkmnStorage() {
        pkmns = new SkyPkmn[PKMN_NUM];
        for(int i=0; i<PKMN_NUM; i++) {
            pkmns[i] = new SkyPkmn();
        }
    }

    public PkmnStorage(BooleanBuffer buf) {
        this();
        load(buf);
    }

    public void load(BooleanBuffer buf) {
        for(int i=0; i<PKMN_NUM; i++) {
            pkmns[i].load(buf.view(PKMN_SIZE));
        }
    }

    public void store(BooleanBuffer buf) {
        for(int i=0; i<PKMN_NUM; i++) {
            pkmns[i].store(buf.view(PKMN_SIZE));
        }
    }

}
