package skyjed.save;

import skyjed.util.ArrayUtils;

public class SaveFile {

    public static final int MIN_FILE_LENGTH = 128*1024;
    public static final int SLOT_LENGTH = 46684;
    public static final int SLOT2_OFFSET = 51200;
    public static final int QSLOT_OFFSET = 102400;
    public static final int QSLOT_LENGTH = 22528;

    private byte[] data;
    public SaveSlot slot1;
    //public SaveSlot slot2; //TODO split slots
    public QuickSaveSlot qslot;

    public SaveFile(byte[] data) {
        this.data = data;
        slot1 = new SaveSlot(ArrayUtils.copyFrom(data, 0, SLOT_LENGTH));
        //slot2 = new SaveSlot(ArrayUtils.copyFrom(data, SLOT2_OFFSET, SLOT_LENGTH)); //TODO split slots
        {
            byte[] qdata = ArrayUtils.copyFrom(data, QSLOT_OFFSET, QSLOT_LENGTH);
            if(QuickSaveSlot.checkMagic(qdata)) {
                qslot = new QuickSaveSlot(qdata);
            } else {
                qslot = null;
            }
        }
    }

    public byte[] toByteA() {
        ArrayUtils.copyInto(data, slot1.toByteA(), 0);
        ArrayUtils.copyInto(data, slot1.toByteA(), SLOT2_OFFSET); //TODO split slots
        //ArrayUtils.copyInto(data, slot2.toByteA(), SLOT2_OFFSET); //TODO split slots
        if(qslot != null) {
            ArrayUtils.copyInto(data, qslot.toByteA(), QSLOT_OFFSET);
        }
        return data;
    }

}
