package skyjed.save;

import skyjed.buffer.BooleanBuffer;
import skyjed.resources.SkyItemRes;
import skyjed.save.util.SkyCopyPasteable;

public class SkyItem implements SkyCopyPasteable {

    public static final int LENGTH = 33;
    public static final String MIME_TYPE = "application/x-sky-item";

    public int getLength() { return LENGTH; }
    public String getMimeType() { return MIME_TYPE; }

    public  static final int LEN_FLAGS = 7;
    private static final int LEN_PARAM = 11;
    private static final int LEN_ID = 11;
    private static final int LEN_HELDBY = 3;

    public boolean isvalid;
    public boolean[] flags;
    public int param;
    public int id;
    public int heldby;

    public SkyItem() {
        flags = new boolean[LEN_FLAGS];
    }

    public SkyItem(int id, int param) {
        this();
        this.isvalid = true;
        this.param = param;
        this.id = id;
    }

    public void load(BooleanBuffer buf) {
        isvalid = buf.get();
        flags = buf.get(LEN_FLAGS);
        param = buf.getInt(LEN_PARAM);
        id = buf.getInt(LEN_ID);
        heldby = buf.getInt(LEN_HELDBY);
    }

    public void store(BooleanBuffer buf) {
        buf.put(isvalid);
        buf.put(flags);
        buf.putInt(param, LEN_PARAM);
        buf.putInt(id, LEN_ID);
        buf.putInt(heldby, LEN_HELDBY);
    }

    public String toString() {
        if(!isvalid) {
            return "----------";
        }
        String desc = SkyItemRes.getInstance().getValue(id);
        if(param > 0) {
            if(this.isBox()) {
                desc += " (" + SkyItemRes.getInstance().getValue(param) + ")";
            } else {
                desc += " (" + param + ")";
            }
        }
        if(heldby > 0) {
            desc += " [" + heldby + "]";
        }
        return desc;
    }

    private boolean isBox() {
        return id > 363 && id < 400;
    }

}
