package skyjed.save.util;

import java.util.List;

import skyjed.buffer.BooleanBuffer;
import skyjed.buffer.BooleanBufferArray;
import skyjed.util.ClipboardHelper;

public class SkyBufferUtils { // TODO this is a mess

    private static final String MIME_CLASS_SINGLE = "; class=\"[Z\"";
    private static final String MIME_CLASS_ARRAY = "; class=\"[[Z\"";

    public static void clear(SkyBufferable obj) {
        boolean[] arr = new boolean[obj.getLength()];
        BooleanBuffer buf = new BooleanBufferArray(arr);
        obj.load(buf);
    }

    public static void cut(SkyCopyPasteable obj) {
        copy(obj);
        clear(obj);
    }

    public static void copy(SkyCopyPasteable obj) {
        boolean[] arr = new boolean[obj.getLength()];
        BooleanBuffer buf = new BooleanBufferArray(arr);
        obj.store(buf);
        ClipboardHelper.setClipboardContents(arr, obj.getMimeType() + MIME_CLASS_SINGLE);
    }

    public static void paste(SkyCopyPasteable obj) {
        boolean[] arr = (boolean[]) ClipboardHelper.getClipboardContents(obj.getMimeType() + MIME_CLASS_SINGLE);
        if(arr == null) return;
        BooleanBuffer buf = new BooleanBufferArray(arr);
        obj.load(buf);
    }

    public static void clearArray(SkyBufferable[] objs) {
        for(int i=0; i<objs.length; i++) {
            boolean[] arr = new boolean[objs[i].getLength()];
            BooleanBuffer buf = new BooleanBufferArray(arr);
            objs[i].load(buf);
        }
    }

    public static void cutArray(SkyCopyPasteable[] objs) {
        copyArray(objs);
        clearArray(objs);
    }

    public static void copyArray(SkyCopyPasteable[] objs) {
        // @javasux if only java had reified generics...
        boolean[][] arr = new boolean[objs.length][objs[0].getLength()];
        for(int i=0; i<objs.length; i++) {
            BooleanBuffer buf = new BooleanBufferArray(arr[i]);
            objs[i].store(buf);
        }
        ClipboardHelper.setClipboardContents(arr, objs[0].getMimeType() + MIME_CLASS_ARRAY);
    }

    public static void pasteArray(SkyCopyPasteable[] objs) {
        boolean[][] arr = (boolean[][]) ClipboardHelper.getClipboardContents(objs[0].getMimeType() + MIME_CLASS_ARRAY);
        if(arr == null) return;
        if(objs.length != arr.length) {
            System.err.println("length mismatch");
            return;
        }
        for(int i=0; i<objs.length; i++) {
            BooleanBuffer buf = new BooleanBufferArray(arr[i]);
            objs[i].load(buf);
        }
    }

    public static void clearList(List<? extends SkyBufferable> objs) {
        for(int i=0; i<objs.size(); i++) {
            boolean[] arr = new boolean[objs.get(i).getLength()];
            BooleanBuffer buf = new BooleanBufferArray(arr);
            objs.get(i).load(buf);
        }
    }

    public static void cutList(List<? extends SkyCopyPasteable> objs) {
        copyList(objs);
        clearList(objs);
    }

    public static void copyList(List<? extends SkyCopyPasteable> objs) {
        boolean[][] arr = new boolean[objs.size()][objs.get(0).getLength()];
        for(int i=0; i<objs.size(); i++) {
            BooleanBuffer buf = new BooleanBufferArray(arr[i]);
            objs.get(i).store(buf);
        }
        ClipboardHelper.setClipboardContents(arr, objs.get(0).getMimeType() + MIME_CLASS_ARRAY);
    }

    public static void pasteList(List<? extends SkyCopyPasteable> objs) {
        boolean[][] arr = (boolean[][]) ClipboardHelper.getClipboardContents(objs.get(0).getMimeType() + MIME_CLASS_ARRAY);
        if(arr == null) return;
        if(objs.size() != arr.length) {
            throw new LengthMismatchException(objs.size(), arr.length);
        }
        for(int i=0; i<objs.size(); i++) {
            BooleanBuffer buf = new BooleanBufferArray(arr[i]);
            objs.get(i).load(buf);
        }
    }

    public static SkyClipboardInfo getInfoForMime(String mime_type) {
        String clipboardMime = ClipboardHelper.getPreferredMimeType();
        if(clipboardMime != null) {
            if(clipboardMime.equals(mime_type + MIME_CLASS_SINGLE)) {
                return new SkyClipboardInfo(SkyClipboardInfo.TYPE_SINGLE);
            }
            if(clipboardMime.equals(mime_type + MIME_CLASS_ARRAY)) {
                boolean[][] arr = (boolean[][]) ClipboardHelper.getClipboardContents(mime_type + MIME_CLASS_ARRAY);
                if(arr == null) return new SkyClipboardInfo(SkyClipboardInfo.TYPE_NONE);
                return new SkyClipboardInfo(SkyClipboardInfo.TYPE_ARRAY, arr.length);
            }
        }
        return new SkyClipboardInfo(SkyClipboardInfo.TYPE_NONE);
    }

}
