package skyjed.save.util;

import skyjed.buffer.BooleanBuffer;
import skyjed.buffer.BooleanBufferArray;
import skyjed.util.BitConverterLE;

public class SkyRawWrapper implements SkyBufferable {

    public SkyBufferable obj;
    public byte[] raw_data;
    private int byte_length;

    public SkyRawWrapper(SkyBufferable obj) {
        if(obj.getLength()%8 != 0) {
            throw(new IllegalArgumentException("obj.getLength() must be a multiple of 8 for SkyRawWrapper"));
        }
        this.obj = obj;
        byte_length = obj.getLength()/8;
        raw_data = new byte[byte_length];
    }

    public int getLength() {
        return obj.getLength();
    }

    public void load(BooleanBuffer buf) {
        raw_data = buf.getBytes(byte_length);
        updObj();
    }

    public void store(BooleanBuffer buf) {
        updRaw();
        buf.putBytes(raw_data);
    }

    public void updRaw() {
        boolean[] arr = BitConverterLE.splitBits(raw_data);
        BooleanBuffer buf = new BooleanBufferArray(arr);
        obj.store(buf);
        raw_data = BitConverterLE.packBits(arr);
    }

    public void updObj() {
        boolean[] arr = BitConverterLE.splitBits(raw_data);
        BooleanBuffer buf = new BooleanBufferArray(arr);
        obj.load(buf);
    }

}
