package skyjed.util;

import java.util.Arrays;
import java.util.List;

import javax.swing.AbstractListModel;
import javax.swing.ComboBoxModel;

public class ArrayListModel<E> extends AbstractListModel<E> implements ComboBoxModel<E> {

    List<E> values;
    private E selectedItem;

    public ArrayListModel(List<E> values) {
        this.values = values;
    }

    public ArrayListModel(E[] values) {
        this.values = Arrays.asList(values);
    }

    public E getElementAt(int index) {
        return values.get(index);
    }

    public int getSize() {
        return values.size();
    }

    public Object getSelectedItem() {
        return selectedItem;
    }

    @SuppressWarnings("unchecked")
    public void setSelectedItem(Object anItem) {
        selectedItem = (E) anItem;
        this.fireContentsChanged(this, -1, -1);
    }

}
