package skyjed.util;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JLabel;

public class JBooleanLabel extends JLabel {

    public JBooleanLabel() {
        this(false);
        //this.addMouseListener(new ZeroOneMouseAdapter());
    }

    public JBooleanLabel(boolean b) {
        this.setBool(b);
        this.addMouseListener(new ZeroOneMouseAdapter());
    }

    public boolean getBool() {
        return this.getText().equals("1");
    }

    public void setBool(boolean b) {
        this.setText(b?"1":"0");
    }

    // byte can be converted to int without cast so this can be used as getByte() too
    public byte getInt() {
        return (byte) (this.getBool()?1:0);
    }

    // byte can be converted to int without cast so this can be used as setByte() too
    public void setInt(int i) {
        this.setBool(i != 0);
    }

    private class ZeroOneMouseAdapter extends MouseAdapter {
        public void mouseReleased(MouseEvent e) {
            JBooleanLabel lbl = (JBooleanLabel) e.getComponent();
            if(lbl.isEnabled() && e.getButton() == MouseEvent.BUTTON1) {
                lbl.setBool(!lbl.getBool());
            }
        }
    }

}
