package skyjed.util;

import javax.swing.JFormattedTextField;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.text.NumberFormatter;

public class JNumberSpinner extends JSpinner {

    public JNumberSpinner(int min, int max) {
        this.setModel(new SpinnerNumberModel(0, min, max, 1)); // val min max step
        JFormattedTextField txt = ((JSpinner.NumberEditor) this.getEditor()).getTextField();
        NumberFormatter formatter = ((NumberFormatter) txt.getFormatter());
        formatter.setAllowsInvalid(false);
        formatter.setCommitsOnValidEdit(true);
    }

    public JNumberSpinner(int max) {
        this(0, max);
    }

    public int getValueInt() {
        return ((Number) this.getValue()).intValue();
    }

    public long getValueLong() {
        return ((Number) this.getValue()).longValue();
    }

}
